diff a/src/hotspot/share/classfile/fieldLayoutBuilder.cpp b/src/hotspot/share/classfile/fieldLayoutBuilder.cpp
--- a/src/hotspot/share/classfile/fieldLayoutBuilder.cpp
+++ b/src/hotspot/share/classfile/fieldLayoutBuilder.cpp
@@ -23,23 +23,26 @@
  */
 
 #include "precompiled.hpp"
 #include "classfile/classFileParser.hpp"
 #include "classfile/fieldLayoutBuilder.hpp"
+#include "classfile/systemDictionary.hpp"
+#include "classfile/vmSymbols.hpp"
 #include "jvm.h"
 #include "memory/resourceArea.hpp"
 #include "oops/array.hpp"
 #include "oops/fieldStreams.inline.hpp"
 #include "oops/instanceMirrorKlass.hpp"
 #include "oops/instanceKlass.inline.hpp"
 #include "oops/klass.inline.hpp"
+#include "oops/inlineKlass.inline.hpp"
 #include "runtime/fieldDescriptor.inline.hpp"
 
-
 LayoutRawBlock::LayoutRawBlock(Kind kind, int size) :
   _next_block(nullptr),
   _prev_block(nullptr),
+  _inline_klass(nullptr),
   _kind(kind),
   _offset(-1),
   _alignment(1),
   _size(size),
   _field_index(-1),
@@ -51,17 +54,18 @@
 
 
 LayoutRawBlock::LayoutRawBlock(int index, Kind kind, int size, int alignment, bool is_reference) :
  _next_block(nullptr),
  _prev_block(nullptr),
+ _inline_klass(nullptr),
  _kind(kind),
  _offset(-1),
  _alignment(alignment),
  _size(size),
  _field_index(index),
  _is_reference(is_reference) {
-  assert(kind == REGULAR || kind == FLATTENED || kind == INHERITED,
+  assert(kind == REGULAR || kind == FLAT || kind == INHERITED,
          "Other kind do not have a field index");
   assert(size > 0, "Sanity check");
   assert(alignment > 0, "Sanity check");
 }
 
@@ -73,22 +77,24 @@
   return _size >= size + adjustment;
 }
 
 FieldGroup::FieldGroup(int contended_group) :
   _next(nullptr),
-  _primitive_fields(nullptr),
+  _small_primitive_fields(nullptr),
+  _big_primitive_fields(nullptr),
   _oop_fields(nullptr),
   _contended_group(contended_group),  // -1 means no contended group, 0 means default contended group
   _oop_count(0) {}
 
 void FieldGroup::add_primitive_field(int idx, BasicType type) {
   int size = type2aelembytes(type);
   LayoutRawBlock* block = new LayoutRawBlock(idx, LayoutRawBlock::REGULAR, size, size /* alignment == size for primitive types */, false);
-  if (_primitive_fields == nullptr) {
-    _primitive_fields = new GrowableArray<LayoutRawBlock*>(INITIAL_LIST_SIZE);
+  if (size >= oopSize) {
+    add_to_big_primitive_list(block);
+  } else {
+    add_to_small_primitive_list(block);
   }
-  _primitive_fields->append(block);
 }
 
 void FieldGroup::add_oop_field(int idx) {
   int size = type2aelembytes(T_OBJECT);
   LayoutRawBlock* block = new LayoutRawBlock(idx, LayoutRawBlock::REGULAR, size, size /* alignment == size for oops */, true);
@@ -97,14 +103,41 @@
   }
   _oop_fields->append(block);
   _oop_count++;
 }
 
+void FieldGroup::add_flat_field(int idx, InlineKlass* vk) {
+  LayoutRawBlock* block = new LayoutRawBlock(idx, LayoutRawBlock::FLAT, vk->get_exact_size_in_bytes(), vk->get_alignment(), false);
+  block->set_inline_klass(vk);
+  if (block->size() >= oopSize) {
+    add_to_big_primitive_list(block);
+  } else {
+    add_to_small_primitive_list(block);
+  }
+}
+
 void FieldGroup::sort_by_size() {
-  if (_primitive_fields != nullptr) {
-    _primitive_fields->sort(LayoutRawBlock::compare_size_inverted);
+  if (_small_primitive_fields != nullptr) {
+    _small_primitive_fields->sort(LayoutRawBlock::compare_size_inverted);
+  }
+  if (_big_primitive_fields != nullptr) {
+    _big_primitive_fields->sort(LayoutRawBlock::compare_size_inverted);
+  }
+}
+
+void FieldGroup::add_to_small_primitive_list(LayoutRawBlock* block) {
+  if (_small_primitive_fields == nullptr) {
+    _small_primitive_fields = new GrowableArray<LayoutRawBlock*>(INITIAL_LIST_SIZE);
+  }
+  _small_primitive_fields->append(block);
+}
+
+void FieldGroup::add_to_big_primitive_list(LayoutRawBlock* block) {
+  if (_big_primitive_fields == nullptr) {
+    _big_primitive_fields = new GrowableArray<LayoutRawBlock*>(INITIAL_LIST_SIZE);
   }
+  _big_primitive_fields->append(block);
 }
 
 FieldLayout::FieldLayout(GrowableArray<FieldInfo>* field_info, ConstantPool* cp) :
   _field_info(field_info),
   _cp(cp),
@@ -136,29 +169,31 @@
     insert(first_empty_block(), new LayoutRawBlock(LayoutRawBlock::RESERVED, instanceOopDesc::base_offset_in_bytes()));
   } else {
     bool has_fields = reconstruct_layout(super_klass);
     fill_holes(super_klass);
     if ((UseEmptySlotsInSupers && !super_klass->has_contended_annotations()) || !has_fields) {
-      _start = _blocks;  // start allocating fields from the first empty block
+      _start = _blocks; // Setting _start to _blocks instead of _last would allow subclasses
+      // to allocate fields in empty slots of their super classes
     } else {
       _start = _last;    // append fields at the end of the reconstructed layout
     }
   }
 }
 
 LayoutRawBlock* FieldLayout::first_field_block() {
-  LayoutRawBlock* block = _start;
-  while (block->kind() != LayoutRawBlock::INHERITED && block->kind() != LayoutRawBlock::REGULAR
-      && block->kind() != LayoutRawBlock::FLATTENED && block->kind() != LayoutRawBlock::PADDING) {
+  LayoutRawBlock* block = _blocks;
+  while (block != nullptr
+         && block->kind() != LayoutRawBlock::INHERITED
+         && block->kind() != LayoutRawBlock::REGULAR
+         && block->kind() != LayoutRawBlock::FLAT) {
     block = block->next_block();
   }
   return block;
 }
 
-
-// Insert a set of fields into a layout using a best-fit strategy.
-// For each field, search for the smallest empty slot able to fit the field
+// Insert a set of fields into a layout.
+// For each field, search for an empty slot able to fit the field
 // (satisfying both size and alignment requirements), if none is found,
 // add the field at the end of the layout.
 // Fields cannot be inserted before the block specified in the "start" argument
 void FieldLayout::add(GrowableArray<LayoutRawBlock*>* list, LayoutRawBlock* start) {
   if (list == nullptr) return;
@@ -168,11 +203,10 @@
   int last_alignment = 0;
   for (int i = 0; i < list->length(); i ++) {
     LayoutRawBlock* b = list->at(i);
     LayoutRawBlock* cursor = nullptr;
     LayoutRawBlock* candidate = nullptr;
-
     // if start is the last block, just append the field
     if (start == last_block()) {
       candidate = last_block();
     }
     // Before iterating over the layout to find an empty slot fitting the field's requirements,
@@ -186,10 +220,11 @@
       last_size = b->size();
       last_alignment = b->alignment();
       cursor = last_block()->prev_block();
       assert(cursor != nullptr, "Sanity check");
       last_search_success = true;
+
       while (cursor != start) {
         if (cursor->kind() == LayoutRawBlock::EMPTY && cursor->fit(b->size(), b->alignment())) {
           if (candidate == nullptr || cursor->size() < candidate->size()) {
             candidate = cursor;
           }
@@ -202,11 +237,10 @@
       }
       assert(candidate != nullptr, "Candidate must not be null");
       assert(candidate->kind() == LayoutRawBlock::EMPTY, "Candidate must be an empty block");
       assert(candidate->fit(b->size(), b->alignment()), "Candidate must be able to store the block");
     }
-
     insert_field_block(candidate, b);
   }
 }
 
 // Used for classes with hard coded field offsets, insert a field at the specified offset */
@@ -301,24 +335,30 @@
     for (AllFieldStream fs(ik->fieldinfo_stream(), ik->constants()); !fs.done(); fs.next()) {
       BasicType type = Signature::basic_type(fs.signature());
       // distinction between static and non-static fields is missing
       if (fs.access_flags().is_static()) continue;
       has_instance_fields = true;
-      int size = type2aelembytes(type);
-      // INHERITED blocks are marked as non-reference because oop_maps are handled by their holder class
-      LayoutRawBlock* block = new LayoutRawBlock(fs.index(), LayoutRawBlock::INHERITED, size, size, false);
+      LayoutRawBlock* block;
+      if (fs.field_flags().is_null_free_inline_type()) {
+        InlineKlass* vk = InlineKlass::cast(ik->get_inline_type_field_klass(fs.index()));
+        block = new LayoutRawBlock(fs.index(), LayoutRawBlock::INHERITED, vk->get_exact_size_in_bytes(),
+                                   vk->get_alignment(), false);
+
+      } else {
+        int size = type2aelembytes(type);
+        // INHERITED blocks are marked as non-reference because oop_maps are handled by their holder class
+        block = new LayoutRawBlock(fs.index(), LayoutRawBlock::INHERITED, size, size, false);
+      }
       block->set_offset(fs.offset());
       all_fields->append(block);
     }
     ik = ik->super() == nullptr ? nullptr : InstanceKlass::cast(ik->super());
   }
-
   all_fields->sort(LayoutRawBlock::compare_offset);
   _blocks = new LayoutRawBlock(LayoutRawBlock::RESERVED, instanceOopDesc::base_offset_in_bytes());
   _blocks->set_offset(0);
   _last = _blocks;
-
   for(int i = 0; i < all_fields->length(); i++) {
     LayoutRawBlock* b = all_fields->at(i);
     _last->set_next_block(b);
     b->set_prev_block(_last);
     _last = b;
@@ -350,22 +390,20 @@
     }
     b = b->next_block();
   }
   assert(b->next_block() == nullptr, "Invariant at this point");
   assert(b->kind() != LayoutRawBlock::EMPTY, "Sanity check");
-
   // If the super class has @Contended annotation, a padding block is
   // inserted at the end to ensure that fields from the subclasses won't share
   // the cache line of the last field of the contended class
   if (super_klass->has_contended_annotations() && ContendedPaddingWidth > 0) {
     LayoutRawBlock* p = new LayoutRawBlock(LayoutRawBlock::PADDING, ContendedPaddingWidth);
     p->set_offset(b->offset() + b->size());
     b->set_next_block(p);
     p->set_prev_block(b);
     b = p;
   }
-
   if (!UseEmptySlotsInSupers) {
     // Add an empty slots to align fields of the subclass on a heapOopSize boundary
     // in order to emulate the behavior of the previous algorithm
     int align = (b->offset() + b->size()) % heapOopSize;
     if (align != 0) {
@@ -375,11 +413,10 @@
       b->set_next_block(p);
       p->set_prev_block(b);
       b = p;
     }
   }
-
   LayoutRawBlock* last = new LayoutRawBlock(LayoutRawBlock::EMPTY, INT_MAX);
   last->set_offset(b->offset() + b->size());
   assert(last->offset() > 0, "Sanity check");
   b->set_next_block(last);
   last->set_prev_block(b);
@@ -438,19 +475,19 @@
                          b->size(),
                          b->alignment(),
                          "REGULAR");
         break;
       }
-      case LayoutRawBlock::FLATTENED: {
+      case LayoutRawBlock::FLAT: {
         FieldInfo* fi = _field_info->adr_at(b->field_index());
         output->print_cr(" @%d \"%s\" %s %d/%d %s",
                          b->offset(),
                          fi->name(_cp)->as_C_string(),
                          fi->signature(_cp)->as_C_string(),
                          b->size(),
                          b->alignment(),
-                         "FLATTENED");
+                         "FLAT");
         break;
       }
       case LayoutRawBlock::RESERVED: {
         output->print_cr(" @%d %d/- %s",
                          b->offset(),
@@ -474,49 +511,60 @@
                   b->size(), // so far, alignment constraint == size, will change with Valhalla
                   "INHERITED");
               found = true;
               break;
             }
-          }
-          ik = ik->java_super();
         }
-        break;
+        ik = ik->java_super();
       }
-      case LayoutRawBlock::EMPTY:
-        output->print_cr(" @%d %d/1 %s",
-                         b->offset(),
-                         b->size(),
-                        "EMPTY");
-        break;
-      case LayoutRawBlock::PADDING:
-        output->print_cr(" @%d %d/1 %s",
-                         b->offset(),
-                         b->size(),
-                        "PADDING");
-        break;
+      break;
+    }
+    case LayoutRawBlock::EMPTY:
+      output->print_cr(" @%d %d/1 %s",
+                       b->offset(),
+                       b->size(),
+                       "EMPTY");
+      break;
+    case LayoutRawBlock::PADDING:
+      output->print_cr(" @%d %d/1 %s",
+                       b->offset(),
+                       b->size(),
+                       "PADDING");
+      break;
     }
     b = b->next_block();
   }
 }
 
 FieldLayoutBuilder::FieldLayoutBuilder(const Symbol* classname, const InstanceKlass* super_klass, ConstantPool* constant_pool,
-      GrowableArray<FieldInfo>* field_info, bool is_contended, FieldLayoutInfo* info) :
+                                       GrowableArray<FieldInfo>* field_info, bool is_contended, bool is_inline_type,
+                                       FieldLayoutInfo* info, Array<InlineKlass*>* inline_type_field_klasses) :
   _classname(classname),
   _super_klass(super_klass),
   _constant_pool(constant_pool),
   _field_info(field_info),
   _info(info),
+  _inline_type_field_klasses(inline_type_field_klasses),
   _root_group(nullptr),
   _contended_groups(GrowableArray<FieldGroup*>(8)),
   _static_fields(nullptr),
   _layout(nullptr),
   _static_layout(nullptr),
   _nonstatic_oopmap_count(0),
   _alignment(-1),
+  _first_field_offset(-1),
+  _exact_size_in_bytes(-1),
+  _atomic_field_count(0),
+  _fields_size_sum(0),
   _has_nonstatic_fields(false),
-  _is_contended(is_contended) {}
-
+  _has_inline_type_fields(false),
+  _is_contended(is_contended),
+  _is_inline_type(is_inline_type),
+  _has_flattening_information(is_inline_type),
+  _has_nonatomic_values(false),
+  _nullable_atomic_flat_candidate(false)
+ {}
 
 FieldGroup* FieldLayoutBuilder::get_or_create_contended_group(int g) {
   assert(g > 0, "must only be called for named contended groups");
   FieldGroup* fg = nullptr;
   for (int i = 0; i < _contended_groups.length(); i++) {
@@ -539,25 +587,27 @@
   _static_layout->initialize_static_layout();
   _static_fields = new FieldGroup();
   _root_group = new FieldGroup();
 }
 
-// Field sorting for regular classes:
+// Field sorting for regular (non-inline) classes:
 //   - fields are sorted in static and non-static fields
 //   - non-static fields are also sorted according to their contention group
 //     (support of the @Contended annotation)
 //   - @Contended annotation is ignored for static fields
-void FieldLayoutBuilder::regular_field_sorting() {
+//   - field flattening decisions are taken in this method
+void FieldLayoutBuilder::regular_field_sorting(TRAPS) {
   int idx = 0;
   for (GrowableArrayIterator<FieldInfo> it = _field_info->begin(); it != _field_info->end(); ++it, ++idx) {
     FieldInfo ctrl = _field_info->at(0);
     FieldGroup* group = nullptr;
     FieldInfo fieldinfo = *it;
     if (fieldinfo.access_flags().is_static()) {
       group = _static_fields;
     } else {
       _has_nonstatic_fields = true;
+      _atomic_field_count++;  // we might decrement this
       if (fieldinfo.field_flags().is_contended()) {
         int g = fieldinfo.contended_group();
         if (g == 0) {
           group = new FieldGroup(true);
           _contended_groups.append(group);
@@ -569,27 +619,69 @@
       }
     }
     assert(group != nullptr, "invariant");
     BasicType type = Signature::basic_type(fieldinfo.signature(_constant_pool));
     switch(type) {
-      case T_BYTE:
-      case T_CHAR:
-      case T_DOUBLE:
-      case T_FLOAT:
-      case T_INT:
-      case T_LONG:
-      case T_SHORT:
-      case T_BOOLEAN:
-        group->add_primitive_field(idx, type);
-        break;
-      case T_OBJECT:
-      case T_ARRAY:
+    case T_BYTE:
+    case T_CHAR:
+    case T_DOUBLE:
+    case T_FLOAT:
+    case T_INT:
+    case T_LONG:
+    case T_SHORT:
+    case T_BOOLEAN:
+      group->add_primitive_field(idx, type);
+      break;
+    case T_OBJECT:
+    case T_ARRAY:
+      if (!fieldinfo.field_flags().is_null_free_inline_type()) {
         if (group != _static_fields) _nonstatic_oopmap_count++;
         group->add_oop_field(idx);
-        break;
-      default:
-        fatal("Something wrong?");
+      } else {
+        assert(type != T_ARRAY, "null free ptr to array not supported");
+        _has_inline_type_fields = true;
+        if (group == _static_fields) {
+          // static fields are never flat
+          group->add_oop_field(idx);
+        } else {
+          // Check below is performed for non-static fields, it should be performed for static fields too but at this stage,
+          // it is not guaranteed that the klass of the static field has been loaded, so the test for static fields is delayed
+          // until the linking phase
+          Klass* klass =  _inline_type_field_klasses->at(idx);
+          assert(klass != nullptr, "Sanity check");
+          InlineKlass* vk = InlineKlass::cast(klass);
+          assert(vk->is_implicitly_constructible(), "must be, should have been checked in post_process_parsed_stream()");
+          _has_flattening_information = true;
+          // Flattening decision to be taken here
+          // This code assumes all verification already have been performed
+          // (field's type has been loaded and it is an inline klass)
+          bool too_big_to_flatten = (InlineFieldMaxFlatSize >= 0 &&
+                                    (vk->size_helper() * HeapWordSize) > InlineFieldMaxFlatSize);
+          bool too_atomic_to_flatten = vk->must_be_atomic() || AlwaysAtomicAccesses;
+          bool too_volatile_to_flatten = fieldinfo.access_flags().is_volatile();
+          if (vk->is_naturally_atomic()) {
+            too_atomic_to_flatten = false;
+            //too_volatile_to_flatten = false; //FIXME
+            // Currently, volatile fields are never flat, this could change in the future
+          }
+          if (!(too_big_to_flatten | too_atomic_to_flatten | too_volatile_to_flatten)) {
+            group->add_flat_field(idx, vk);
+            _nonstatic_oopmap_count += vk->nonstatic_oop_map_count();
+            _field_info->adr_at(idx)->field_flags_addr()->update_flat(true);
+            if (!vk->is_atomic()) {  // flat and non-atomic: take note
+              _has_nonatomic_values = true;
+              _atomic_field_count--;  // every other field is atomic but this one
+            }
+          } else {
+            _nonstatic_oopmap_count++;
+            group->add_oop_field(idx);
+          }
+        }
+      }
+      break;
+    default:
+      fatal("Something wrong?");
     }
   }
   _root_group->sort_by_size();
   _static_fields->sort_by_size();
   if (!_contended_groups.is_empty()) {
@@ -597,87 +689,276 @@
       _contended_groups.at(i)->sort_by_size();
     }
   }
 }
 
+/* Field sorting for inline classes:
+ *   - because inline classes are immutable, the @Contended annotation is ignored
+ *     when computing their layout (with only read operation, there's no false
+ *     sharing issue)
+ *   - this method also records the alignment of the field with the most
+ *     constraining alignment, this value is then used as the alignment
+ *     constraint when flattening this inline type into another container
+ *   - field flattening decisions are taken in this method (those decisions are
+ *     currently only based in the size of the fields to be flattened, the size
+ *     of the resulting instance is not considered)
+ */
+void FieldLayoutBuilder::inline_class_field_sorting(TRAPS) {
+  assert(_is_inline_type, "Should only be used for inline classes");
+  int alignment = 1;
+  for (GrowableArrayIterator<FieldInfo> it = _field_info->begin(); it != _field_info->end(); ++it) {
+    FieldGroup* group = nullptr;
+    FieldInfo fieldinfo = *it;
+    int field_alignment = 1;
+    if (fieldinfo.access_flags().is_static()) {
+      group = _static_fields;
+    } else {
+      _has_nonstatic_fields = true;
+      _atomic_field_count++;  // we might decrement this
+      group = _root_group;
+    }
+    assert(group != nullptr, "invariant");
+    BasicType type = Signature::basic_type(fieldinfo.signature(_constant_pool));
+    switch(type) {
+    case T_BYTE:
+    case T_CHAR:
+    case T_DOUBLE:
+    case T_FLOAT:
+    case T_INT:
+    case T_LONG:
+    case T_SHORT:
+    case T_BOOLEAN:
+      if (group != _static_fields) {
+        field_alignment = type2aelembytes(type); // alignment == size for primitive types
+      }
+      group->add_primitive_field(fieldinfo.index(), type);
+      break;
+    case T_OBJECT:
+    case T_ARRAY:
+      if (!fieldinfo.field_flags().is_null_free_inline_type()) {
+        if (group != _static_fields) {
+          _nonstatic_oopmap_count++;
+          field_alignment = type2aelembytes(type); // alignment == size for oops
+        }
+        group->add_oop_field(fieldinfo.index());
+      } else {
+        assert(type != T_ARRAY, "null free ptr to array not supported");
+        _has_inline_type_fields = true;
+        if (group == _static_fields) {
+          // static fields are never flat
+          group->add_oop_field(fieldinfo.index());
+        } else {
+          // Check below is performed for non-static fields, it should be performed for static fields too but at this stage,
+          // it is not guaranteed that the klass of the static field has been loaded, so the test for static fields is delayed
+          // until the linking phase
+          Klass* klass =  _inline_type_field_klasses->at(fieldinfo.index());
+          assert(klass != nullptr, "Sanity check");
+          InlineKlass* vk = InlineKlass::cast(klass);
+          assert(vk->is_implicitly_constructible(), "must be, should have been checked in post_process_parsed_stream()");
+          // Flattening decision to be taken here
+          // This code assumes all verifications have already been performed
+          // (field's type has been loaded and it is an inline klass)
+          bool too_big_to_flatten = (InlineFieldMaxFlatSize >= 0 &&
+                                    (vk->size_helper() * HeapWordSize) > InlineFieldMaxFlatSize);
+          bool too_atomic_to_flatten = vk->must_be_atomic() || AlwaysAtomicAccesses;
+          bool too_volatile_to_flatten = fieldinfo.access_flags().is_volatile();
+          if (vk->is_naturally_atomic()) {
+            too_atomic_to_flatten = false;
+            //too_volatile_to_flatten = false; //FIXME
+            // Currently, volatile fields are never flat, this could change in the future
+          }
+          if (!(too_big_to_flatten | too_atomic_to_flatten | too_volatile_to_flatten)) {
+            group->add_flat_field(fieldinfo.index(), vk);
+            _nonstatic_oopmap_count += vk->nonstatic_oop_map_count();
+            field_alignment = vk->get_alignment();
+            _field_info->adr_at(fieldinfo.index())->field_flags_addr()->update_flat(true);
+            if (!vk->is_atomic()) {  // flat and non-atomic: take note
+              _has_nonatomic_values = true;
+              _atomic_field_count--;  // every other field is atomic but this one
+            }
+          } else {
+            _nonstatic_oopmap_count++;
+            field_alignment = type2aelembytes(T_OBJECT);
+            group->add_oop_field(fieldinfo.index());
+          }
+        }
+      }
+      break;
+    default:
+      fatal("Unexpected BasicType");
+    }
+    if (!fieldinfo.access_flags().is_static() && field_alignment > alignment) alignment = field_alignment;
+  }
+  _alignment = alignment;
+  if (!_has_nonstatic_fields) {
+    // There are a number of fixes required throughout the type system and JIT
+    Exceptions::fthrow(THREAD_AND_LOCATION,
+                       vmSymbols::java_lang_ClassFormatError(),
+                       "Value Types do not support zero instance size yet");
+    return;
+  }
+}
+
 void FieldLayoutBuilder::insert_contended_padding(LayoutRawBlock* slot) {
   if (ContendedPaddingWidth > 0) {
     LayoutRawBlock* padding = new LayoutRawBlock(LayoutRawBlock::PADDING, ContendedPaddingWidth);
     _layout->insert(slot, padding);
   }
 }
 
-// Computation of regular classes layout is an evolution of the previous default layout
-// (FieldAllocationStyle 1):
-//   - primitive fields are allocated first (from the biggest to the smallest)
-//   - then oop fields are allocated, either in existing gaps or at the end of
-//     the layout
-void FieldLayoutBuilder::compute_regular_layout() {
+/* Computation of regular classes layout is an evolution of the previous default layout
+ * (FieldAllocationStyle 1):
+ *   - primitive fields (both primitive types and flat inline types) are allocated
+ *     first, from the biggest to the smallest
+ *   - then oop fields are allocated (to increase chances to have contiguous oops and
+ *     a simpler oopmap).
+ */
+void FieldLayoutBuilder::compute_regular_layout(TRAPS) {
   bool need_tail_padding = false;
   prologue();
-  regular_field_sorting();
-
+  regular_field_sorting(CHECK);
   if (_is_contended) {
     _layout->set_start(_layout->last_block());
     // insertion is currently easy because the current strategy doesn't try to fill holes
     // in super classes layouts => the _start block is by consequence the _last_block
     insert_contended_padding(_layout->start());
     need_tail_padding = true;
   }
-  _layout->add(_root_group->primitive_fields());
+  _layout->add(_root_group->big_primitive_fields());
+  _layout->add(_root_group->small_primitive_fields());
   _layout->add(_root_group->oop_fields());
 
   if (!_contended_groups.is_empty()) {
     for (int i = 0; i < _contended_groups.length(); i++) {
       FieldGroup* cg = _contended_groups.at(i);
       LayoutRawBlock* start = _layout->last_block();
       insert_contended_padding(start);
-      _layout->add(cg->primitive_fields(), start);
+      _layout->add(cg->big_primitive_fields());
+      _layout->add(cg->small_primitive_fields(), start);
       _layout->add(cg->oop_fields(), start);
       need_tail_padding = true;
     }
   }
 
   if (need_tail_padding) {
     insert_contended_padding(_layout->last_block());
   }
+  // Warning: IntanceMirrorKlass expects static oops to be allocated first
+  _static_layout->add_contiguously(_static_fields->oop_fields());
+  _static_layout->add(_static_fields->big_primitive_fields());
+  _static_layout->add(_static_fields->small_primitive_fields());
 
-  _static_layout->add_contiguously(this->_static_fields->oop_fields());
-  _static_layout->add(this->_static_fields->primitive_fields());
+  epilogue();
+}
+
+/* Computation of inline classes has a slightly different strategy than for
+ * regular classes. Regular classes have their oop fields allocated at the end
+ * of the layout to increase GC performances. Unfortunately, this strategy
+ * increases the number of empty slots inside an instance. Because the purpose
+ * of inline classes is to be embedded into other containers, it is critical
+ * to keep their size as small as possible. For this reason, the allocation
+ * strategy is:
+ *   - big primitive fields (primitive types and flat inline type smaller
+ *     than an oop) are allocated first (from the biggest to the smallest)
+ *   - then oop fields
+ *   - then small primitive fields (from the biggest to the smallest)
+ */
+void FieldLayoutBuilder::compute_inline_class_layout(TRAPS) {
+  prologue();
+  inline_class_field_sorting(CHECK);
+  // Inline types are not polymorphic, so they cannot inherit fields.
+  // By consequence, at this stage, the layout must be composed of a RESERVED
+  // block, followed by an EMPTY block.
+  assert(_layout->start()->kind() == LayoutRawBlock::RESERVED, "Unexpected");
+  assert(_layout->start()->next_block()->kind() == LayoutRawBlock::EMPTY, "Unexpected");
+  LayoutRawBlock* first_empty = _layout->start()->next_block();
+  if (first_empty->offset() % _alignment != 0) {
+    LayoutRawBlock* padding = new LayoutRawBlock(LayoutRawBlock::PADDING, _alignment - (first_empty->offset() % _alignment));
+    _layout->insert(first_empty, padding);
+    _layout->set_start(padding->next_block());
+  }
+
+  _layout->add(_root_group->big_primitive_fields());
+  _layout->add(_root_group->oop_fields());
+  _layout->add(_root_group->small_primitive_fields());
+
+  LayoutRawBlock* first_field = _layout->first_field_block();
+   if (first_field != nullptr) {
+     _first_field_offset = _layout->first_field_block()->offset();
+     _exact_size_in_bytes = _layout->last_block()->offset() - _layout->first_field_block()->offset();
+   } else {
+     // special case for empty value types
+     _first_field_offset = _layout->blocks()->size();
+     _exact_size_in_bytes = 0;
+   }
+  _exact_size_in_bytes = _layout->last_block()->offset() - _layout->first_field_block()->offset();
+
+  // Warning:: InstanceMirrorKlass expects static oops to be allocated first
+  _static_layout->add_contiguously(_static_fields->oop_fields());
+  _static_layout->add(_static_fields->big_primitive_fields());
+  _static_layout->add(_static_fields->small_primitive_fields());
 
   epilogue();
 }
 
+void FieldLayoutBuilder::add_flat_field_oopmap(OopMapBlocksBuilder* nonstatic_oop_maps,
+                InlineKlass* vklass, int offset) {
+  int diff = offset - vklass->first_field_offset();
+  const OopMapBlock* map = vklass->start_of_nonstatic_oop_maps();
+  const OopMapBlock* last_map = map + vklass->nonstatic_oop_map_count();
+  while (map < last_map) {
+    nonstatic_oop_maps->add(map->offset() + diff, map->count());
+    map++;
+  }
+}
+
+void FieldLayoutBuilder::register_embedded_oops_from_list(OopMapBlocksBuilder* nonstatic_oop_maps, GrowableArray<LayoutRawBlock*>* list) {
+  if (list != nullptr) {
+    for (int i = 0; i < list->length(); i++) {
+      LayoutRawBlock* f = list->at(i);
+      if (f->kind() == LayoutRawBlock::FLAT) {
+        InlineKlass* vk = f->inline_klass();
+        assert(vk != nullptr, "Should have been initialized");
+        if (vk->contains_oops()) {
+          add_flat_field_oopmap(nonstatic_oop_maps, vk, f->offset());
+        }
+      }
+    }
+  }
+}
+
+void FieldLayoutBuilder::register_embedded_oops(OopMapBlocksBuilder* nonstatic_oop_maps, FieldGroup* group) {
+  if (group->oop_fields() != nullptr) {
+    for (int i = 0; i < group->oop_fields()->length(); i++) {
+      LayoutRawBlock* b = group->oop_fields()->at(i);
+      nonstatic_oop_maps->add(b->offset(), 1);
+    }
+  }
+  register_embedded_oops_from_list(nonstatic_oop_maps, group->big_primitive_fields());
+  register_embedded_oops_from_list(nonstatic_oop_maps, group->small_primitive_fields());
+}
+
 void FieldLayoutBuilder::epilogue() {
   // Computing oopmaps
   int super_oop_map_count = (_super_klass == nullptr) ? 0 :_super_klass->nonstatic_oop_map_count();
   int max_oop_map_count = super_oop_map_count + _nonstatic_oopmap_count;
-
   OopMapBlocksBuilder* nonstatic_oop_maps =
       new OopMapBlocksBuilder(max_oop_map_count);
   if (super_oop_map_count > 0) {
     nonstatic_oop_maps->initialize_inherited_blocks(_super_klass->start_of_nonstatic_oop_maps(),
     _super_klass->nonstatic_oop_map_count());
   }
-
-  if (_root_group->oop_fields() != nullptr) {
-    for (int i = 0; i < _root_group->oop_fields()->length(); i++) {
-      LayoutRawBlock* b = _root_group->oop_fields()->at(i);
-      nonstatic_oop_maps->add(b->offset(), 1);
-    }
-  }
-
+  register_embedded_oops(nonstatic_oop_maps, _root_group);
   if (!_contended_groups.is_empty()) {
     for (int i = 0; i < _contended_groups.length(); i++) {
       FieldGroup* cg = _contended_groups.at(i);
       if (cg->oop_count() > 0) {
         assert(cg->oop_fields() != nullptr && cg->oop_fields()->at(0) != nullptr, "oop_count > 0 but no oop fields found");
-        nonstatic_oop_maps->add(cg->oop_fields()->at(0)->offset(), cg->oop_count());
+        register_embedded_oops(nonstatic_oop_maps, cg);
       }
     }
   }
-
   nonstatic_oop_maps->compact();
 
   int instance_end = align_up(_layout->last_block()->offset(), wordSize);
   int static_fields_end = align_up(_static_layout->last_block()->offset(), wordSize);
   int static_fields_size = (static_fields_end -
@@ -689,21 +970,44 @@
   _info->oop_map_blocks = nonstatic_oop_maps;
   _info->_instance_size = align_object_size(instance_end / wordSize);
   _info->_static_field_size = static_fields_size;
   _info->_nonstatic_field_size = (nonstatic_field_end - instanceOopDesc::base_offset_in_bytes()) / heapOopSize;
   _info->_has_nonstatic_fields = _has_nonstatic_fields;
-
-  if (PrintFieldLayout) {
+  _info->_has_inline_fields = _has_inline_type_fields;
+
+  // An inline type is naturally atomic if it has just one field, and
+  // that field is simple enough.
+  _info->_is_naturally_atomic = (_is_inline_type &&
+                                 (_atomic_field_count <= 1) &&
+                                 !_has_nonatomic_values &&
+                                 _contended_groups.is_empty());
+  // This may be too restrictive, since if all the fields fit in 64
+  // bits we could make the decision to align instances of this class
+  // to 64-bit boundaries, and load and store them as single words.
+  // And on machines which supported larger atomics we could similarly
+  // allow larger values to be atomic, if properly aligned.
+
+
+  if (PrintFieldLayout || (PrintInlineLayout && _has_flattening_information)) {
     ResourceMark rm;
     tty->print_cr("Layout of class %s", _classname->as_C_string());
     tty->print_cr("Instance fields:");
     _layout->print(tty, false, _super_klass);
     tty->print_cr("Static fields:");
     _static_layout->print(tty, true, nullptr);
     tty->print_cr("Instance size = %d bytes", _info->_instance_size * wordSize);
+    if (_is_inline_type) {
+      tty->print_cr("First field offset = %d", _first_field_offset);
+      tty->print_cr("Alignment = %d bytes", _alignment);
+      tty->print_cr("Exact size = %d bytes", _exact_size_in_bytes);
+    }
     tty->print_cr("---");
   }
 }
 
-void FieldLayoutBuilder::build_layout() {
-  compute_regular_layout();
+void FieldLayoutBuilder::build_layout(TRAPS) {
+  if (_is_inline_type) {
+    compute_inline_class_layout(CHECK);
+  } else {
+    compute_regular_layout(CHECK);
+  }
 }